import torch
import torch.nn.functional as F
import torch.nn as nn

class Shot(nn.Module):
    def __init__(self):
        super(Shot, self).__init__()
        self.cn01 = nn.Conv2d(25,1,1,padding=0,bias=False)

    def forward(self, f0):
        f1 = self.cn01(f0)
        return f1


class Reconstruct(nn.Module):
    def __init__(self):
        super(Reconstruct, self).__init__()
        self.cn02 = nn.Conv2d(3,5,5,padding=2)
        self.cn03 = nn.Conv2d(5,12,5,padding=2)
        self.cn04 = nn.Conv2d(12,25,5,padding=2)

    def forward(self, f1):
        f2 = self.cn02(f1)
        f3 = self.cn03(f2)
        f4 = self.cn04(f3)
        return f4


class VeryDeepSuperResolution(nn.Module):
    def __init__(self):
        super(VeryDeepSuperResolution, self).__init__()
        self.cn01 = nn.Conv2d(25,64,3,padding=1)
        self.cn02 = nn.Conv2d(64,64,3,padding=1)
        self.cn03 = nn.Conv2d(64,64,3,padding=1)
        self.cn04 = nn.Conv2d(64,64,3,padding=1)
        self.cn05 = nn.Conv2d(64,64,3,padding=1)
        self.cn06 = nn.Conv2d(64,64,3,padding=1)
        self.cn07 = nn.Conv2d(64,64,3,padding=1)
        self.cn08 = nn.Conv2d(64,64,3,padding=1)
        self.cn09 = nn.Conv2d(64,64,3,padding=1)
        self.cn10 = nn.Conv2d(64,64,3,padding=1)
        self.cn11 = nn.Conv2d(64,64,3,padding=1)
        self.cn12 = nn.Conv2d(64,64,3,padding=1)
        self.cn13 = nn.Conv2d(64,64,3,padding=1)
        self.cn14 = nn.Conv2d(64,64,3,padding=1)
        self.cn15 = nn.Conv2d(64,64,3,padding=1)
        self.cn16 = nn.Conv2d(64,64,3,padding=1)
        self.cn17 = nn.Conv2d(64,64,3,padding=1)
        self.cn18 = nn.Conv2d(64,64,3,padding=1)
        self.cn19 = nn.Conv2d(64,64,3,padding=1)
        self.cnL = nn.Conv2d(64,25,3,padding=1)

    def forward(self, x):
        f = F.relu(self.cn01(x))
        f = F.relu(self.cn02(f))
        f = F.relu(self.cn03(f))
        f = F.relu(self.cn04(f))
        f = F.relu(self.cn05(f))
        f = F.relu(self.cn06(f))
        f = F.relu(self.cn07(f))
        f = F.relu(self.cn08(f))
        f = F.relu(self.cn09(f))
        f = F.relu(self.cn10(f))
        f = F.relu(self.cn11(f))
        f = F.relu(self.cn12(f))
        f = F.relu(self.cn13(f))
        f = F.relu(self.cn14(f))
        f = F.relu(self.cn15(f))
        f = F.relu(self.cn16(f))
        f = F.relu(self.cn17(f))
        f = F.relu(self.cn18(f))
        f = F.relu(self.cn19(f))
        f = self.cnL(f)
        return f + x
